



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java实现敏感词过滤（DFA算法）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java实现敏感词过滤（DFA算法）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 02:06:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>小Alan在最近的开发中遇到了敏感词过滤，便去网上查阅了很多敏感词过滤的资料，在这里也和大家分享一下自己的理解。</p>
<p>敏感词过滤应该是不用给大家过多的解释吧？讲白了就是你在项目中输入某些字（比如输入xxoo相关的文字时）时要能检</p>
<p>测出来，很多项目中都会有一个敏感词管理模块，在敏感词管理模块中你可以加入敏感词，然后根据加入的敏感词去过滤输</p>
<p>入内容中的敏感词并进行相应的处理，要么提示，要么高亮显示，要么直接替换成其它的文字或者符号代替。</p>
<p>敏感词过滤的做法有很多，我简单描述我现在理解的几种：</p>
<p>①查询数据库当中的敏感词，循环每一个敏感词，然后去输入的文本中从头到尾搜索一遍，看是否存在此敏感词，有则做相</p>
<p>应的处理，这种方式讲白了就是找到一个处理一个。</p>
<p>优点：so easy。用java代码实现基本没什么难度。</p>
<p>缺点：这效率让我心中奔过十万匹草泥马，而且匹配的是不是有些蛋疼，如果是英文时你会发现一个很无语的事情，比如英文</p>
<p>a是敏感词，那我如果是一篇英文文档，那程序它妹的得处理多少次敏感词？谁能告诉我？</p>
<p>②传说中的DFA算法（有穷自动机）,也正是我要给大家分享的，毕竟感觉比较通用，算法的原理希望大家能够自己去网上查查</p>
<p>资料，这里就不详细说明了。</p>
<p>优点：至少比上面那sb效率高点。</p>
<p>缺点：对于学过算法的应该不难，对于没学过算法的用起来也不难，就是理解起来有点gg疼，匹配效率也不高，比较耗费内存，</p>
<p>敏感词越多，内存占用的就越大。</p>
<p>③第三种在这里要特别说明一下，那就是你自己去写一个算法吧，或者在现有的算法的基础上去优化，这也是小Alan追求的至</p>
<p>高境界之一，如果哪位淫兄有自己的想法一定别忘了小Alan，可以加小Alan的QQ：810104041教小Alan两招耍耍。</p>
<p>那么，传说中的DFA算法是怎么实现的呢？</p>
<p>第一步：敏感词库初始化（将敏感词用DFA算法的原理封装到敏感词库中，敏感词库采用HashMap保存），代码如下：</p>
<div>
<pre class="prettyprint linenums"> package com.cfwx.rox.web.sysmgr.util;

 import java.util.HashMap;<br />
 import java.util.HashSet;<br />
 import java.util.Iterator;<br />
 import java.util.List;<br />
 import java.util.Map;<br />
 import java.util.Set;

 import com.cfwx.rox.web.common.model.entity.SensitiveWord;

 /**<br />
  * 敏感词库初始化<br />
  *<br />
  * @author AlanLee<br />
  *<br />
  */<br />
 public class SensitiveWordInit<br />
 {<br />
     /**<br />
      * 敏感词库<br />
      */<br />
     public HashMap sensitiveWordMap;

     /**<br />
      * 初始化敏感词<br />
      *<br />
      * @return<br />
      */<br />
     public Map initKeyWord(List&lt;SensitiveWord&gt; sensitiveWords)<br />
     {<br />
         try<br />
         {<br />
             // 从敏感词集合对象中取出敏感词并封装到Set集合中<br />
             Set&lt;String&gt; keyWordSet = new HashSet&lt;String&gt;();<br />
             for (SensitiveWord s : sensitiveWords)<br />
             {<br />
                 keyWordSet.add(s.getContent().trim());<br />
             }<br />
             // 将敏感词库加入到HashMap中<br />
             addSensitiveWordToHashMap(keyWordSet);<br />
         }<br />
         catch (Exception e)<br />
         {<br />
             e.printStackTrace();<br />
         }<br />
         return sensitiveWordMap;<br />
     }

     /**<br />
      * 封装敏感词库<br />
      *<br />
      * @param keyWordSet<br />
      */<br />
     @SuppressWarnings("rawtypes")<br />
     private void addSensitiveWordToHashMap(Set&lt;String&gt; keyWordSet)<br />
     {<br />
         // 初始化HashMap对象并控制容器的大小<br />
         sensitiveWordMap = new HashMap(keyWordSet.size());<br />
         // 敏感词<br />
         String key = null;<br />
         // 用来按照相应的格式保存敏感词库数据<br />
         Map nowMap = null;<br />
         // 用来辅助构建敏感词库<br />
         Map&lt;String, String&gt; newWorMap = null;<br />
         // 使用一个迭代器来循环敏感词集合<br />
         Iterator&lt;String&gt; iterator = keyWordSet.iterator();<br />
         while (iterator.hasNext())<br />
         {<br />
             key = iterator.next();<br />
             // 等于敏感词库，HashMap对象在内存中占用的是同一个地址，所以此nowMap对象的变化，sensitiveWordMap对象也会跟着改变<br />
             nowMap = sensitiveWordMap;<br />
             for (int i = 0; i &lt; key.length(); i++)<br />
             {<br />
                 // 截取敏感词当中的字，在敏感词库中字为HashMap对象的Key键值<br />
                 char keyChar = key.charAt(i);

                 // 判断这个字是否存在于敏感词库中<br />
                 Object wordMap = nowMap.get(keyChar);<br />
                 if (wordMap != null)<br />
                 {<br />
                     nowMap = (Map) wordMap;<br />
                 }<br />
                 else<br />
                 {<br />
                     newWorMap = new HashMap&lt;String, String&gt;();<br />
                     newWorMap.put("isEnd", "0");<br />
                     nowMap.put(keyChar, newWorMap);<br />
                     nowMap = newWorMap;<br />
                 }

                 // 如果该字是当前敏感词的最后一个字，则标识为结尾字<br />
                 if (i == key.length() - 1)<br />
                 {<br />
                     nowMap.put("isEnd", "1");<br />
                 }<br />
                 System.out.println("封装敏感词库过程："+sensitiveWordMap);<br />
             }<br />
             System.out.println("查看敏感词库数据:" + sensitiveWordMap);<br />
         }<br />
     }<br />
 }</pre>
</div>
<p>第二步：写一个敏感词过滤工具类，里面可以写上自己需要的方法，代码如下：</p>
<div>
<pre class="prettyprint linenums"> package com.cfwx.rox.web.sysmgr.util;

 import java.util.HashSet;<br />
 import java.util.Iterator;<br />
 import java.util.Map;<br />
 import java.util.Set;

 /**<br />
  * 敏感词过滤工具类<br />
  *<br />
  * @author AlanLee<br />
  *<br />
  */<br />
 public class SensitivewordEngine<br />
 {<br />
     /**<br />
      * 敏感词库<br />
      */<br />
     public static Map sensitiveWordMap = null;

     /**<br />
      * 只过滤最小敏感词<br />
      */<br />
     public static int minMatchTYpe = 1;

     /**<br />
      * 过滤所有敏感词<br />
      */<br />
     public static int maxMatchType = 2;

     /**<br />
      * 敏感词库敏感词数量<br />
      *<br />
      * @return<br />
      */<br />
     public static int getWordSize()<br />
     {<br />
         if (SensitivewordEngine.sensitiveWordMap == null)<br />
         {<br />
             return 0;<br />
         }<br />
         return SensitivewordEngine.sensitiveWordMap.size();<br />
     }

     /**<br />
      * 是否包含敏感词<br />
      *<br />
      * @param txt<br />
      * @param matchType<br />
      * @return<br />
      */<br />
     public static boolean isContaintSensitiveWord(String txt, int matchType)<br />
     {<br />
         boolean flag = false;<br />
         for (int i = 0; i &lt; txt.length(); i++)<br />
         {<br />
             int matchFlag = checkSensitiveWord(txt, i, matchType);<br />
             if (matchFlag &gt; 0)<br />
             {<br />
                 flag = true;<br />
             }<br />
         }<br />
         return flag;<br />
     }

     /**<br />
      * 获取敏感词内容<br />
      *<br />
      * @param txt<br />
      * @param matchType<br />
      * @return 敏感词内容<br />
      */<br />
     public static Set&lt;String&gt; getSensitiveWord(String txt, int matchType)<br />
     {<br />
         Set&lt;String&gt; sensitiveWordList = new HashSet&lt;String&gt;();

         for (int i = 0; i &lt; txt.length(); i++)<br />
         {<br />
             int length = checkSensitiveWord(txt, i, matchType);<br />
             if (length &gt; 0)<br />
             {<br />
                 // 将检测出的敏感词保存到集合中<br />
                 sensitiveWordList.add(txt.substring(i, i + length));<br />
                 i = i + length - 1;<br />
             }<br />
         }

         return sensitiveWordList;<br />
     }

     /**<br />
      * 替换敏感词<br />
      *<br />
      * @param txt<br />
      * @param matchType<br />
      * @param replaceChar<br />
      * @return<br />
      */<br />
     public static String replaceSensitiveWord(String txt, int matchType, String replaceChar)<br />
     {<br />
         String resultTxt = txt;<br />
         Set&lt;String&gt; set = getSensitiveWord(txt, matchType);<br />
         Iterator&lt;String&gt; iterator = set.iterator();<br />
         String word = null;<br />
         String replaceString = null;<br />
         while (iterator.hasNext())<br />
         {<br />
             word = iterator.next();<br />
             replaceString = getReplaceChars(replaceChar, word.length());<br />
             resultTxt = resultTxt.replaceAll(word, replaceString);<br />
         }

         return resultTxt;<br />
     }

     /**<br />
      * 替换敏感词内容<br />
      *<br />
      * @param replaceChar<br />
      * @param length<br />
      * @return<br />
      */<br />
     private static String getReplaceChars(String replaceChar, int length)<br />
     {<br />
         String resultReplace = replaceChar;<br />
         for (int i = 1; i &lt; length; i++)<br />
         {<br />
             resultReplace += replaceChar;<br />
         }

         return resultReplace;<br />
     }

     /**<br />
      * 检查敏感词数量<br />
      *<br />
      * @param txt<br />
      * @param beginIndex<br />
      * @param matchType<br />
      * @return<br />
      */<br />
     public static int checkSensitiveWord(String txt, int beginIndex, int matchType)<br />
     {<br />
         boolean flag = false;<br />
         // 记录敏感词数量<br />
         int matchFlag = 0;<br />
         char word = 0;<br />
         Map nowMap = SensitivewordEngine.sensitiveWordMap;<br />
         for (int i = beginIndex; i &lt; txt.length(); i++)<br />
         {<br />
             word = txt.charAt(i);<br />
             // 判断该字是否存在于敏感词库中<br />
             nowMap = (Map) nowMap.get(word);<br />
             if (nowMap != null)<br />
             {<br />
                 matchFlag++;<br />
                 // 判断是否是敏感词的结尾字，如果是结尾字则判断是否继续检测<br />
                 if ("1".equals(nowMap.get("isEnd")))<br />
                 {<br />
                     flag = true;<br />
                     // 判断过滤类型，如果是小过滤则跳出循环，否则继续循环<br />
                     if (SensitivewordEngine.minMatchTYpe == matchType)<br />
                     {<br />
                         break;<br />
                     }<br />
                 }<br />
             }<br />
             else<br />
             {<br />
                 break;<br />
             }<br />
         }<br />
         if (!flag)<br />
         {<br />
             matchFlag = 0;<br />
         }<br />
         return matchFlag;<br />
     }

 }</pre>
</div>
<p>第三步：一切都准备就绪，当然是查询好数据库当中的敏感词，并且开始过滤咯，代码如下：</p>
<div>
<pre class="prettyprint linenums">  @SuppressWarnings("rawtypes")<br />
     @Override<br />
     public Set&lt;String&gt; sensitiveWordFiltering(String text)<br />
     {<br />
         // 初始化敏感词库对象<br />
         SensitiveWordInit sensitiveWordInit = new SensitiveWordInit();<br />
         // 从数据库中获取敏感词对象集合（调用的方法来自Dao层，此方法是service层的实现类）<br />
         List&lt;SensitiveWord&gt; sensitiveWords = sensitiveWordDao.getSensitiveWordListAll();<br />
         // 构建敏感词库<br />
         Map sensitiveWordMap = sensitiveWordInit.initKeyWord(sensitiveWords);<br />
         // 传入SensitivewordEngine类中的敏感词库<br />
         SensitivewordEngine.sensitiveWordMap = sensitiveWordMap;<br />
         // 得到敏感词有哪些，传入2表示获取所有敏感词<br />
         Set&lt;String&gt; set = SensitivewordEngine.getSensitiveWord(text, 2);<br />
         return set;<br />
     }</pre>
</div>
<p>最后一步：在Controller层写一个方法给前端请求，前端获取到需要的数据并进行相应的处理，代码如下：</p>
<div>
<pre class="prettyprint linenums">  /**<br />
      * 敏感词过滤<br />
      *<br />
      * @param text<br />
      * @return<br />
      */<br />
     @RequestMapping(value = "/word/filter")<br />
     @ResponseBody<br />
     public RespVo sensitiveWordFiltering(String text)<br />
     {<br />
         RespVo respVo = new RespVo();<br />
         try<br />
         {<br />
             Set&lt;String&gt; set = sensitiveWordService.sensitiveWordFiltering(text);<br />
             respVo.setResult(set);<br />
         }<br />
         catch (Exception e)<br />
         {<br />
             throw new RoxException("过滤敏感词出错，请联系维护人员");<br />
         }

         return respVo;<br />
     }</pre>
</div>
<p>小Alan在代码中写了不少的注释，希望大家能够动动自己的脑筋好好的理解一下。</p>
<p>可爱博主：AlanLee</p>
<p>博客地址：<a href="http://www.cnblogs.com/AlanLee" rel="external nofollow noreferrer">http://www.cnblogs.com/AlanLee</a></p>
<p>本文出自博客园，欢迎大家加入博客园。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390ykr48.html">pgm revert转换 成jpg 人脸识别图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/495kv1m9.html">ASP&period;Net Session&comma; Cookie&comma; Cache的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ve3048.html">Git tricks&colon; Unstaging files</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm50d49.html">PHP魔术方法小结&period;md</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1k1ng8.html">（转）CSS字体大小&colon; em与px、pt、百分比之间的对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1z4jj8.html">&lbrack;转&rsqb;机器学习&amp;amp&semi;数据挖掘笔记&lowbar;16（常见面试之机器学习算法思想简单梳理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd2e3k8.html">Sql Server添加用户</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vowom8.html">C&num; Socket SSL通讯笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mejkd6q.html">POJ 2104：K-th Number（整体二分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy12pyxq.html">They Are Everywhere</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j2xll8.html">static class  - 静态类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk5xj08.html">kairosdb &plus; cassandra Setup</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpz4zvq.html">selinux导致docker启动失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k7yj59.html">我是如何将博客转成PDF的</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj04m69.html">RTX腾讯通字体全变成横着的了</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjj0vr9.html">linux从0开始----01</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyre2xq.html">css 其他</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xyoe9.html">Spring Boot &plus; Spring Cloud 构建微服务系统（二）：服务消费和负载（Ribbon）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r3xno9.html">mybatis&ast;中DefaultVFS的logger乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/953n4mm8.html">字符串匹配算法之 kmp算法 （python版）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/jqdgzvqd.html">ucos实时操作系统学习笔记&mdash;&mdash;任务间通信（互斥锁）</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9337w93.html">我对BFC的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8myk68k.html">&amp;quot&semi;用户增长&amp;quot&semi;--快速身份认证实现用户增长的技术和产品方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jvxw95.html">微信硬件H5面板开发&lpar;二&rpar; ---- 实现一个灯的控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96zl4q4.html">MongoDB Java Driver操作指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rkeeq0.html">ABP教程-对Person信息进行操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1d30qg.html">Linux命令：ps&comma;netstat&comma;top</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q73ok8e.html">Oracle数据库自动备份SQL文本：Procedure存储过程&comma;View视图&comma;Function函数&comma;Trigger触发器&comma;Sequence序列号等</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r35d90.html">web标准之道&mdash;&mdash;笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jrelq5.html">【SQL】关于无法附加文件的错误</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
